using System;
using System.IO;
using System.Collections;
using org.bouncycastle.io;

namespace org.bouncycastle.asn1
{
	/**
	* @deprecated use DERSequence.
	*/
	public class DERConstructedSequence: ASN1Sequence
	{
		public override void addObject(
			DEREncodable obj) 
		{
			base.addObject(obj);
		}

		public int getSize()
		{
			return size();
		}

		/*
		* A note on the implementation:
		* <p>
		* As DER requires the constructed, definite-length model to
		* be used for structured types, this varies slightly from the
		* ASN.1 descriptions given. Rather than just outputing SEQUENCE,
		* we also have to specify CONSTRUCTED, and the objects length.
		*/
		public override void encode(DEROutputStream outStream)
			//throws IOException
		{
			MemoryStream   bOut = new MemoryStream();
			DEROutputStream         dOut = new DEROutputStream(bOut);
			IEnumerator             e = this.getObjects();

			while (e.MoveNext())
			{
				Object    obj = e.Current;

				dOut.writeObject(obj);
			}

			dOut.close();

			byte[]  bytes = bOut.ToArray();

			outStream.writeEncoded(DERTags.SEQUENCE | DERTags.CONSTRUCTED, bytes);
		}
	}

}