using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	public class AttCertValidityPeriod: DEREncodable
	{
		DERGeneralizedTime  notBeforeTime;
		DERGeneralizedTime  notAfterTime;

		public AttCertValidityPeriod(
			ASN1Sequence    seq)
		{
			notBeforeTime = (DERGeneralizedTime)seq.getObjectAt(0);
			notAfterTime = (DERGeneralizedTime)seq.getObjectAt(1);
		}

		public DERGeneralizedTime getNotBeforeTime()
		{
			return notBeforeTime;
		}

		public DERGeneralizedTime getNotAfterTime()
		{
			return notAfterTime;
		}

		/**
		 * <pre>
		 *  AttCertValidityPeriod  ::= SEQUENCE {
		 *       notBeforeTime  GeneralizedTime,
		 *       notAfterTime   GeneralizedTime
		 *  } 
		 * </pre>
		 */
		public DERObject getDERObject()
		{
			ASN1EncodableVector  v = new ASN1EncodableVector();

			v.add(notBeforeTime);
			v.add(notAfterTime);

			return new DERSequence(v);
		}
	}

}