
using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	public class CRLReason: DEREnumerated
	{
		public static readonly int UNSPECIFIED = 0;
		public static readonly int KEY_COMPROMISE = 1;
		public static readonly int CA_COMPROMISE = 2;
		public static readonly int AFFILIATION_CHANGED = 3;
		public static readonly int SUPERSEDED = 4;
		public static readonly int CESSATION_OF_OPERATION  = 5;
		public static readonly int CERTIFICATE_HOLD = 6;
		public static readonly int REMOVE_FROM_CRL = 8;
		public static readonly int PRIVILEGE_WITHDRAWN = 9;
		public static readonly int AA_COMPROMISE = 10;

		/**
		 * <pre>
		 * CRLReason ::= ENUMERATED {
		 *  unspecified             (0),
		 *  keyCompromise           (1),
		 *  cACompromise            (2),
		 *  affiliationChanged      (3),
		 *  superseded              (4),
		 *  cessationOfOperation    (5),
		 *  certificateHold         (6),
		 *  removeFromCRL           (8),
		 *  privilegeWithdrawn      (9),
		 *  aACompromise           (10)
		 * }
		 * </pre>
		 */
		public CRLReason(
			int reason): base(reason) {}

		public CRLReason(
			DEREnumerated reason): base(reason.getValue().intValue()) {}
	}

}