using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	public class GeneralNames: DEREncodable
	{
		ASN1Sequence            seq;
		bool                 isInsideImplicit = false;

		public static GeneralNames getInstance(
			Object  obj)
		{
			
			if ((obj == null) || (typeof(GeneralNames).IsInstanceOfType(obj)))
			{
				return (GeneralNames)obj;
			}

			if (typeof(ASN1Sequence).IsInstanceOfType(obj))
			{
				return new GeneralNames((ASN1Sequence)obj);
			}

			throw new ArgumentException("illegal object in getInstance: " + obj.GetType().ToString());
		}

		public static GeneralNames getInstance(
			ASN1TaggedObject obj,
			bool          flagExplicit)
		{
			return getInstance(ASN1Sequence.getInstance(obj, flagExplicit));
		}

		public GeneralNames(
			ASN1Sequence  seq)
		{
			this.seq = seq;
		}

		/*
		* this is a hack! But it will have to do until the ambiguity rules
		* get sorted out for implicit/explicit tagging...
		* @deprecated
		*/
		public void markInsideImplicit(
			bool    isInsideImplicit)
		{
			this.isInsideImplicit = isInsideImplicit;
		}

		/**
		* <pre>
		* GeneralNames ::= SEQUENCE SIZE {1..MAX} OF GeneralName
		* </pre>
		*/
		public DERObject getDERObject()
		{
			return seq;
		}
	}

}