using System;
using org.bouncycastle.math;

namespace org.bouncycastle.crypto.parameters
{
	public class ElGamalPublicKeyParameters : ElGamalKeyParameters
	{
		private BigInteger      y;

		public ElGamalPublicKeyParameters(
			BigInteger      y,
			ElGamalParameters    parameters) : base(false, parameters)
		{
			this.y = y;
		}   

		public BigInteger getY()
		{
			return y;
		}

		public override bool Equals(
			Object  obj)
		{
			if (!(typeof(ElGamalPublicKeyParameters).IsInstanceOfType(obj))) return false;
			ElGamalPublicKeyParameters   pKey = (ElGamalPublicKeyParameters)obj;
			if (!pKey.getY().Equals(y))
			{
				return false;
			}
			return base.Equals(obj);
		}
		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

	}

}